package greenfoot;

import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.MotionEvent;

final class GameGestureListener extends SimpleOnGestureListener
{
    @Override
	public boolean onSingleTapUp(MotionEvent event){
		Greenfoot.touchManager.bufferedMouseInfo.isSingleTapped = true;
		return true;
	}
	
	@Override
	public boolean onDoubleTap(MotionEvent event){
		Greenfoot.touchManager.bufferedMouseInfo.isDoubleTapped = true;
		return true;
	}
	
	@Override
	public boolean onScroll(MotionEvent downEvent, MotionEvent moveEvent, float dx, float dy){
		Greenfoot.touchManager.bufferedMouseInfo.isDragged = true;
		return true;
	}
	
	@Override
	public void onLongPress(MotionEvent event){
		Greenfoot.touchManager.bufferedMouseInfo.isLongPressed = true;
	}
}
