package greenfoot;

import android.app.Activity;
import android.os.Bundle;

import android.view.SurfaceView;
import android.view.Window;
import android.view.WindowManager;

//init the window and set it fullScreen
public class GreenfootApp extends Activity {
	
	//enterance of the program
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		//set fullScreen
		this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		
		//init the game
		Greenfoot.init(this);
		if(Greenfoot.debug)
		try{
			setWorld();
		}
		catch(Exception e){
			Greenfoot.addErrLines(e);
			setWorld(new World());
		}
		else
		setWorld();
	}
	
	public void setWorld(){
		Greenfoot.setWorld(new World());
	}
	
	public void setWorld(World world){
		Greenfoot.setWorld(world);
	}
}
