package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Alkesh extends Enemies
{
    private int speed = 2;
    private int hp = 400;
    private boolean initiated;

    /**
     * Setting the variables
     */
    public Alkesh()
    {
        initiated = false;
    }

    /**
     * moving left
     */
    public void moveLeft()
    {
        setLocation (getX() - speed, getY() );
    }

    /**
     * 
     */
    public void act() 
    {
        if(!initiated)
        {
            super.overlapping1();
            initiated = true;
        }
        if(touches(N_bomb.class))
        {
            getWorld().addObject(new Naquadah_Explosion(), getX(), getY());
            remove(N_bomb.class);
            die();
        } else if(touches(Naquadah_Explosion.class))
        {
            die();
        } else if(touches(F302_bullet.class))
        {
            die();
        }else 
        {
            if(touches(Drone.class))
            {
                remove(Drone.class);
                hp = hp - Drone.damage;
            }
            if(hp < 10)
            {
                die();
            } else
            {
                if(getX() > 1)
                {
                    moveLeft();
                    int shoot = Greenfoot.getRandomNumber(100);
                    if(shoot == 2)
                    {
                        getWorld().addObject(new Alkesh_fire(), getX(), getY());
                    }
                } else
                {
                    getWorld().removeObject(this);
                }
            }
        }
    }
    
    /**
     * completes death with chance to produce a powerup
     */

    private void die()
    {
        int heavyAmmo = Greenfoot.getRandomNumber(5) + 1;
        switch(heavyAmmo)
        {
            case 2: getWorld().addObject(new HeavyAmmo(), getX(), getY());
        }
        int F302Support = Greenfoot.getRandomNumber(10) + 1;
        switch(F302Support)
        {
            case 1: getWorld().addObject(new F302Incoming(), getX(), getY());
        }
        getWorld().addObject(new Explosion(200), getX(), getY());

        try
        {
            Endless endless = (Endless) getWorld(); 
            endless.addScore(50);
        } catch(ClassCastException es) {}
        getWorld().removeObject(this);
    }
}