package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Write a description of class Bee here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Death_Glider_staff extends Death_Glider_attack
{
    private GreenfootImage[] images;
    private int currentImage = 0;

    private static final int speed = 20;
    public static final int damage = 5;
    public int playerY;
    private boolean created;

    /**
     * Constructs an animated actor.
     */
    public Death_Glider_staff()
    {
        images = new GreenfootImage[2];
        for(int i=0; i < 2; i++) 
        {
            images[i] = new GreenfootImage("staff shoot " + i + ".png");
        }
        setImage(images[currentImage]);
        // Greenfoot.playSound("staff.wav");
        created = false;
    }

    public void act() 
    {
        if(!created)
        {
            try
            {
            try   
            {
                Endless endless = (Endless) getWorld();
                if(getX() > endless.jumper.getX() + 50)
                {
                    turnTowards(endless.jumper.getX(), endless.jumper.getY());
                }
            }  catch(ClassCastException ex)
            {
                Level level = (Level) getWorld();
                if(getX() > level.jumper.getX() + 50)
                {
                    turnTowards(level.jumper.getX(), level.jumper.getY());
                }
            }
            } catch(IllegalStateException as)
            {
                setRotation(180);
            }
            created = true;
        }
        if(currentImage < 1)
        {
            currentImage = (currentImage + 1);
            setImage(images[currentImage]);
        } else
        {
            currentImage = 0;
        }
        if(getX() > 1)
        {
            if(!touches(JumperShield.class))
            {
                if(!touches(Jumper.class))
                {
                    move(speed);
                } else if(touches(Jumper.class))
                {
                    try   
                    {
                        Endless endless = (Endless) getWorld();
                        endless.hpbar.subtract(damage / 2);
                    }  catch(ClassCastException ex)
                    {
                        Level level = (Level) getWorld();
                        level.hpbar.subtract(damage / 2);
                    }
                    getWorld().removeObject(this);
                }  
            } else if(touches(JumperShield.class))
            {
                try   
                {
                    Endless endless = (Endless) getWorld();
                    endless.shbar.subtract(damage);
                }  catch(ClassCastException ex)
                {
                    Level level = (Level) getWorld();
                    level.shbar.subtract(damage);
                }
                getWorld().removeObject(this);
            }
        } else
        {
            getWorld().removeObject(this);
        }
    }
}