package stargate;

import greenfoot.*; // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Endless here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Endless extends World {
	public Bar hpbar = new Bar("", "Health Points", 60, 60, Color.RED,
			Color.GREEN);
	public Bar hwbar = new Bar("", "Heavy Munition", 5, 10, Color.RED,
			Color.RED);
	public Bar lwbar = new Bar("", "Light Munition", 50, 50, Color.RED,
			Color.RED);
	public Bar shbar = new Bar("", "Shield Power", 100, 200, Color.YELLOW,
			Color.YELLOW);
	public GreenfootImage user;

	public Jumper jumper;
	private int score = 0;
	String name;
	GreenfootImage userImg;
	private boolean userImage;
	public boolean mouseC;
	private boolean zpm;
	private double zpmt;

	public Endless() {
		super(1000, 600, 1);
		GreenfootImage background = new GreenfootImage(1000, 600);
		scrollingImage = getScrollingImage(1000, 600);
		background.drawImage(scrollingImage, 0, 0);
		setBackground(background);
		addObject(new Counter("Score: "), 200, 50);
		addObject(hpbar, getWidth() / 2, 20);
		addObject(lwbar, getWidth() / 2, 40);
		addObject(hwbar, getWidth() / 2, 60);
		addObject(shbar, getWidth() / 2, 80);
		jumper = new Jumper();
		addObject(jumper, 43, 314);
		mouseC = jumper.mouseC;

		ClassImageManager.setClassImage(Alkesh.class, new GreenfootImage(
				"Al'kesh.png"));
		ClassImageManager.setClassImage(Explosion.class, new GreenfootImage(
				"explosion.png"));
		ClassImageManager.setClassImage(Wraith_Dart.class, new GreenfootImage(
				"wraith dart.png"));
		ClassImageManager.setClassImage(Death_Glider.class, new GreenfootImage(
				"Death Glider.png"));
		ClassImageManager.setClassImage(Death_Glider_staff.class,
				new GreenfootImage("staff shoot 1.png"));
		ClassImageManager.setClassImage(Wraith_Dart_energy.class,
				new GreenfootImage("wraith dart energy weapon.png"));
		ClassImageManager.setClassImage(Alkesh_fire.class, new GreenfootImage(
				"Al'kesh 1.png"));
		ClassImageManager.setClassImage(F302.class, new GreenfootImage(
				"f-302.png"));
		ClassImageManager.setClassImage(F302_bullet.class, new GreenfootImage(
				"f-302 bullet.png"));
		ClassImageManager.setClassImage(ZPM.class, new GreenfootImage(
				"zpm powerup.png"));
		ClassImageManager.setClassImage(F302Incoming.class, new GreenfootImage(
				"frame 1 -- f302 powerup.png"));
		ClassImageManager.setClassImage(HeavyAmmo.class, new GreenfootImage(
				"frame 1 -- weapon powerup.png"));
		ClassImageManager.setClassImage(Counter.class, new GreenfootImage(
				"Counter.png"));
		ClassImageManager.setClassImage(Naquadah_Explosion.class,
				new GreenfootImage("naquadah explosion.png"));
		ClassImageManager.setClassImage(Jumper.class, new GreenfootImage(
				"jumper.png"));
		ClassImageManager.setClassImage(Drone.class, new GreenfootImage(
				"drone.png"));
		ClassImageManager.setClassImage(N_bomb.class, new GreenfootImage(
				"naquadah bomb.png"));
		ClassImageManager.setClassImage(JumperShield.class, new GreenfootImage(
				"shield1.png"));

		Greenfoot.start();
		Greenfoot.setInputMod(Greenfoot.mouseMod);
		// StartMenu.opening.play();
		bombs = 0;
		drones = 0;
		zpmt = 0;
		zpm = false;
		setBackground(new GreenfootImage("space1.jpg"));
	}

	private static final GreenfootImage bgImage = new GreenfootImage(
			"space1.jpg");
	private static final int scrollSpeed = 2;
	private GreenfootImage scrollingImage;
	private int scrollPosition = 0;

	public int button;
	public int shootHW = 0;
	public boolean died = false;

	private boolean scroll = true;
	private boolean shoot = true;
	private boolean spawnEnemies = true;
	private boolean reproduce = true;
	public boolean shield = true;

	private double sh = 0;
	private double bombs;
	private double drones;

	@SuppressWarnings("unused")
	// it is used, but eclipse wants that
	public void act() {
		if (shoot) {
			// if (jumper.mouseC) {
			// MouseInfo mouse = Greenfoot.getMouseInfo();
			// int button;
			// if (Greenfoot.mouseClicked(null)) {
			// button = mouse.getButton();
			// if (button == 1) {
			// if (lwbar.getValue() > 0) {
			// if (System.currentTimeMillis() > drones + 100) {
			// jumper.drones();
			// lwbar.subtract(1);
			// drones = System.currentTimeMillis();
			// }
			// }
			// } else if (button == 2) {
			// System.out.println("shield");
			// if (shield && System.currentTimeMillis() > sh + 1000) {
			// addObject(new JumperShield(), jumper.getX(),
			// jumper.getY());
			// shield = false;
			// sh = System.currentTimeMillis();
			// System.out.println("on");
			// } else if (!shield
			// && System.currentTimeMillis() > sh + 1000) {
			// try {
			// removeObject(((JumperShield) getObjects(
			// JumperShield.class).get(0)));
			// shield = true;
			// } catch (IndexOutOfBoundsException as) {
			//
			// }
			// sh = System.currentTimeMillis();
			// System.out.println("off");
			// }
			// } else if (button == 3) {
			// if (hwbar.getValue() > 0) {
			// if (System.currentTimeMillis() > bombs + 3000) {
			// jumper.n_bomb();
			// shootHW = 2;
			// hwbar.subtract(1);
			// bombs = System.currentTimeMillis();
			// }
			// }
			// }
			// }
			// }
			// else
			// {
			if (Greenfoot.mouseClicked(null)) {
				if (key("L")
						|| (mouseLocation("right") && (mouseLocation("up") || mouseLocation("down")))) {
					if (hwbar.getValue() > 0) {
						if (System.currentTimeMillis() > bombs + 3000) {
							jumper.n_bomb();
							shootHW = 2;
							hwbar.subtract(1);
							bombs = System.currentTimeMillis();
						}
					}
				} else if (key("J") || mouseLocation("right")) {
					if (lwbar.getValue() > 0) {
						if (System.currentTimeMillis() > drones + 100) {
							jumper.drones();
							lwbar.subtract(1);
							drones = System.currentTimeMillis();
						}
					}
				} else if (key("K") || MouseIsNear(50, jumper)) {
					if (shield && System.currentTimeMillis() > sh + 1000) {
						addObject(new JumperShield(), jumper.getX(),
								jumper.getY());
						shield = false;
						sh = System.currentTimeMillis();
					} else if (!shield
							&& System.currentTimeMillis() > sh + 1000) {
						try {
							removeObject(((JumperShield) getObjects(
									JumperShield.class).get(0)));
							shield = true;
						} catch (IndexOutOfBoundsException as) {

						}
						sh = System.currentTimeMillis();
					}
				}
			}
		}
		// if (Greenfoot.isKeyDown("m")) {
		// // StartMenu.opening.stop();
		// }
		if (scroll) {
			if (scrollSpeed > 0 && scrollPosition <= 0) {
				scrollPosition = getWidth();
			}
			if (scrollSpeed < 0 && scrollPosition >= getWidth()) {
				scrollPosition = 0;
			}
			scrollPosition -= scrollSpeed;
			paint(scrollPosition);
		}
		if (hpbar.getValue() < 1) {
			if (!died) {
				addObject(new Explosion(200), jumper.getX(), jumper.getY());
				removeObject(jumper);
				shoot = false;
				scroll = false;
				spawnEnemies = false;
				died = true;
				reproduce = false;
				shield = false;
			}
			if (numberOfObjects() == 5) {
				dye();
			}
		}
		if (spawnEnemies) {
			int spawnAlkesh = Greenfoot.getRandomNumber(500) + 1;
			switch (spawnAlkesh) {
			case 68:
				spawn("Alkesh", Greenfoot.getRandomNumber(10));
			case 132:
				spawn("Alkesh", Greenfoot.getRandomNumber(10));
			}

			int spawnDeathGlider = Greenfoot.getRandomNumber(250) + 1;
			switch (spawnDeathGlider) {
			case 68:
				spawn("Death_Glider", Greenfoot.getRandomNumber(5));
			case 132:
				spawn("Death_Glider", Greenfoot.getRandomNumber(5));
			}

			int spawnWraithDart = Greenfoot.getRandomNumber(300) + 1;
			switch (spawnWraithDart) {
			case 68:
				spawn("Wraith_Dart", Greenfoot.getRandomNumber(5));
			case 132:
				spawn("Wraith_Dart", Greenfoot.getRandomNumber(5));
			}
		}
		if (reproduce) {
			reproducing();
		}
		if (zpm) {
			if (zpmt == 0) {
				zpmt = System.currentTimeMillis();
				jumper.setImage("jumper_zpm.png");
			}
			if (System.currentTimeMillis() < zpmt + (60 * 1000)) {
				shbar.setValue(200);
				lwbar.setValue(50);
				jumper.setImage("jumper_zpm.png");
			} else {
				setZPM(false);
				zpmt = 0;
				jumper.setImage("jumper.png");
			}
		}
	}

	public void spawn(String type, int position) {
		switch (position) {
		case 0:
			addObject(createActor(type), getWidth(), 120);
			break;
		case 1:
			addObject(createActor(type), getWidth(), 200);
			break;
		case 2:
			addObject(createActor(type), getWidth(), 300);
			break;
		case 3:
			addObject(createActor(type), getWidth(), 400);
			break;
		case 4:
			addObject(createActor(type), getWidth(), 500);
			break;
		case 5:
			addObject(createActor(type), getWidth(), 160);
			break;
		case 6:
			addObject(createActor(type), getWidth(), 250);
			break;
		case 7:
			addObject(createActor(type), getWidth(), 350);
			break;
		case 8:
			addObject(createActor(type), getWidth(), 450);
			break;
		case 9:
			addObject(createActor(type), getWidth(), 560);
			break;
		}
	}

	private Actor createActor(String type) {
		if (type.equals("F302"))
			return new F302();
		if (type.equals("Alkesh"))
			return new Alkesh();
		if (type.equals("Wraith_Dart"))
			return new Wraith_Dart();
		if (type.equals("Death_Glider"))
			return new Death_Glider();
		if (type.equals("Jumper_shield"))
			return new JumperShield();
		return new F302_bullet();
	}

	public void spawnS(String type) {
		addObject(createActor(type), 1, 120);
		addObject(createActor(type), 1, 200);
		addObject(createActor(type), 1, 300);
		addObject(createActor(type), 1, 400);
		addObject(createActor(type), 1, 500);
	}

	private double lwreproduce = System.currentTimeMillis();
	private double shreproduce = System.currentTimeMillis();

	private void reproducing() {
		if (System.currentTimeMillis() > lwreproduce + 800) {
			lwreproduce = System.currentTimeMillis();
			lwbar.add(1);
		}
		if (System.currentTimeMillis() > shreproduce + 1300) {
			shreproduce = System.currentTimeMillis();
			shbar.add(1);
		}
	}

	/**
	 * Paint scrolling image at given position and make sure the rest of the
	 * background is also painted with the same image.
	 */
	private void paint(int position) {
		GreenfootImage bg = getBackground();
		bg.drawImage(scrollingImage, position, 0);
		bg.drawImage(scrollingImage, position - scrollingImage.getWidth(), 0);
		if (userImage) {
			bg.drawImage(userImg, 25, 25);
		}
	}

	/**
	 * Returns an image with the given dimensions.
	 */
	private GreenfootImage getScrollingImage(int width, int height) {
		GreenfootImage image = new GreenfootImage(width, height);
		for (int x = 0; x < width; x += bgImage.getWidth()) {
			for (int y = 0; y < height; y += bgImage.getHeight()) {
				image.drawImage(bgImage, x, y);
			}
		}
		return image;
	}

	public void addHW(int HW) {
		hwbar.add(HW);
	}

	public void jumperSupport() {
		spawnS("F302");
	}

	public void addScore(int value) {
		score = score + value;
	}

	public int getScore() {
		return score;
	}

	public void setZPM(boolean setting) {
		zpm = setting;
	}

	public void dye()// adds the scoreboard telling you what level you were on
	{
		removeObject(hpbar);
		removeObject(lwbar);
		removeObject(hwbar);
		removeObject(shbar);
		// addObject(new ScoreBoard(1000, 600), getWidth() / 2, getHeight() /
		// 2);
	}

	/**
	 * returns if a key is pressed
	 */
	public boolean key(String key) {
		if (Greenfoot.isKeyDown(key)) {
			return true;
		} else {
			return false;
		}
	}

	public boolean mouseLocation(String loc) {
		MouseInfo mouse = Greenfoot.getMouseInfo();
		int mouseX = mouse.getX();
		int mouseY = mouse.getY();
		if (loc.equals("right") && mouseX > getWidth() / 3 * 2)
			return true;
		if (loc.equals("up") && mouseY < getHeight() / 3)
			return true;
		if (loc.equals("left") && mouseX < getWidth() / 3)
			return true;
		if (loc.equals("down") && mouseY > getHeight() / 3 * 2)
			return true;

		return false;

	}
	
	public boolean MouseIsNear(int distance, Actor actor)
	{
		MouseInfo mouse = Greenfoot.getMouseInfo();
		int distanceX = 200;
		int distanceY = 200;
		if(mouse.getX() > actor.getX()) distanceX = mouse.getX() - actor.getX();
		else distanceX = actor.getX() - mouse.getX();
		if(mouse.getY() > actor.getY()) distanceY = mouse.getY() - actor.getY();
		else distanceY = actor.getY() - mouse.getY();
		if(distanceX < distance && distanceY < distance) return true;
		return false;
		
	}
}