package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

import java.util.*;

/**
 * I don't think here is anything needed
 * as documentary. It is the code of lunarlander 
 */
public class Explosion  extends Actor
{
    private final static int IMAGE_COUNT = 12;
    private static GreenfootImage[] images;
    private int imageNo = 0;
    private int increment = 1;
    //GreenfootSound explode = new GreenfootSound("explode.wav");
    int sizes = 1;

    public Explosion(int sizes2)
    {
        initializeImages();
        //explode.setVolume(100);
        sizes = sizes2;
        //explode.play();
        setImage ( images[0] );
    }

    @SuppressWarnings("rawtypes")
	public boolean touches(Class clss)
    {
        Actor enemy = getOneIntersectingObject(clss);
        return enemy != null;
    }

    public void initializeImages()
    {
        if ( images == null )
        {
            GreenfootImage baseImage = new GreenfootImage("explosion.png");
            images = new GreenfootImage[IMAGE_COUNT];
            for ( int i = 0; i < IMAGE_COUNT; i++ )
            {
                int size = (i+1) * ((baseImage.getWidth() / IMAGE_COUNT) + (sizes));
                images[i] = new GreenfootImage(baseImage);
                images[i].scale(size, size);
            }
        }
    }

    @SuppressWarnings("rawtypes")
	private void explodeOthers() 
    {        
        List explodeEm = getIntersectingObjects(N_bomb.class);        
        Iterator i = explodeEm.iterator();
        while(i.hasNext()) {
            N_bomb a = (N_bomb) i.next();
            /*if( ! (a instanceof Explosion)) { //Don't explode other explosions
            int x = a.getX();
            int y = a.getY();
            //Replace other object with an explosion
            getWorld().removeObject(a);
            }*/
            getWorld().removeObject(a);
        }
    }

    public void act() 
    {
        setImage(images[imageNo]);
        imageNo += increment;
        if (imageNo >= IMAGE_COUNT)
        {
            increment = -increment;
            imageNo += increment;
        }

        explodeOthers();

        if ( imageNo < 0 )
        {
            getWorld().removeObject(this);
        }
    }    
}