package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
/**
 * gives Heavy Weapons
 */
public class ZPM extends Powerup
{
    private GreenfootImage images;
    private int speed = 5;
    private double radius2;
    /**
     * setting image
     */
    public ZPM()
    {
        images = new GreenfootImage("zpm powerup.png");
        setImage(images);
        radius2 = System.currentTimeMillis();
    }

    @SuppressWarnings("unused")
	public void act() 
    {
        if(touches(Jumper.class))
        {
            try
            {
                Endless endless = (Endless) getWorld();
                endless.setZPM(true);
            } catch(ClassCastException ex)
            {
                Level level = (Level) getWorld();
                //                 level.setZPM(true);
            }
            getWorld().removeObject(this);
        } else if(!touches(Jumper.class))
        {
            if(getX() > 0)
            {
                moveLeft(speed);
                if(System.currentTimeMillis() > radius2 + 100)    
                {
                    if(getRotation() > 359)
                    {
                        setRotation(0);
                    }
                    setRotation(getRotation() + 10);
                    radius2 = System.currentTimeMillis();
                }
            } else
            {
                getWorld().removeObject(this);
            }
        }
    }
}