 

import greenfoot.*;

/**
 * Write a description of class Bee here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Alkesh_fire extends Alkesh_attack {
	private GreenfootImage[] images;
	private int currentImage = 0;

	@SuppressWarnings("unused")
	private static final int speed = 10;
	public static final int damage = 15;
	public int playerY;
	public boolean created = false;

	/**
	 * Constructs an animated actor.
	 */
	public Alkesh_fire() {
		images = new GreenfootImage[2];
		for (int i = 0; i < 2; i++) {
			images[i] = new GreenfootImage("Al'kesh " + i + ".png");
		}
		setImage(images[currentImage]);
		// Greenfoot.playSound("al'kesh fire.wav");
	}

	public void act() {
		if (currentImage < 1) {
			currentImage = (currentImage + 1);
			setImage(images[currentImage]);
		} else {
			currentImage = 0;
		}
		if (getX() > 1) {
			if (!touches(JumperShield.class)) {
				if (!touches(Jumper.class)) {
					// moveLeft(speed);
					move(5);
					if (!created) {
						try {
							try {
								Endless endless = (Endless) getWorld();
								turnTowards(endless.jumper.getX(),
										endless.jumper.getY());
							} catch (ClassCastException ex) {
								Level level = (Level) getWorld();
								turnTowards(level.jumper.getX(),
										level.jumper.getY());
							}
						} catch (IllegalStateException as) {
							setRotation(180);
						}
						created = true;
					}
				} else if (touches(Jumper.class)) {
					try {
						Endless endless = (Endless) getWorld();
						endless.hpbar.subtract(damage);
					} catch (ClassCastException ex) {
						Level level = (Level) getWorld();
						level.hpbar.subtract(damage);
					}
					getWorld().removeObject(this);
				}
			} else if (touches(JumperShield.class)) {
				try {
					Endless endless = (Endless) getWorld();
					endless.shbar.subtract(damage / 2);
				} catch (ClassCastException ex) {
					Level level = (Level) getWorld();
					level.shbar.subtract(damage / 2);
				}
				getWorld().removeObject(this);
			}
		} else {
			getWorld().removeObject(this);
		}
	}
}