 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
   /**
    * I don't think here is anything needed
    * as documentary. It is the code of the
    * other explosion, just greater
    */
public class Naquadah_Explosion  extends Actor
{
    private final static int IMAGE_COUNT = 12;
    private static GreenfootImage[] images;
    private int imageNo = 0;
    private int increment = 1;
    //GreenfootSound explode = new GreenfootSound("explode.wav");

    public Naquadah_Explosion()
    {
        initializeImages();
    //    explode.setVolume(100);
      //  explode.play();
        setImage ( images[0] );
    }

    @SuppressWarnings("rawtypes")
	public boolean touches(Class clss)
    {
        Actor enemy = getOneIntersectingObject(clss);
        return enemy != null;
    }

    public void initializeImages()
    {
        if ( images == null )
        {
            GreenfootImage baseImage = new GreenfootImage("naquadah explosion.png");
            images = new GreenfootImage[IMAGE_COUNT];
            for ( int i = 0; i < IMAGE_COUNT; i++ )
            {
                int size = (i+1) * ((baseImage.getWidth() / IMAGE_COUNT));
                images[i] = new GreenfootImage(baseImage);
                images[i].scale(size, size);
            }
        }
    }

    @SuppressWarnings({ "rawtypes", "unused" })
	private void explodeOthers() 
    {        
        List explodeEm = getIntersectingObjects(N_bomb.class);        
        Iterator i = explodeEm.iterator();
        while(i.hasNext()) {
            Actor a = (Actor) i.next();
            if(!(a instanceof Explosion) && !(a instanceof Jumper)) { //Don't explode other explosions
                int x = a.getX();
                int y = a.getY();
                getWorld().removeObject(a);
            }
        }
    }

    public void act() 
    {
        setImage(images[imageNo]);
        imageNo += increment;
        if (imageNo >= IMAGE_COUNT)
        {
            increment = -increment;
            imageNo += increment;
        }

        explodeOthers();

        if ( imageNo < 0 )
        {
            getWorld().removeObject(this);
        }
    }    
}
