 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * to organize and give basic methods
 */
public class Powerup extends Actor
{
    /**
     * moving down
     */
    public void moveDown(int speed)
    {
        setLocation (getX(), getY() + (speed / 2));
    }

    /**
     * moving up
     */
    public void moveUp(int speed)
    {
        setLocation (getX(), getY() - (speed / 2));   
    }

    /**
     * moving left
     */
    public void moveLeft(int speed)
    {
        setLocation (getX() - speed, getY() );
    }

    /**
     * checks if touching something
     */
    @SuppressWarnings("rawtypes")
	public boolean touches(Class clss)
    {
        Actor player = getOneIntersectingObject(clss);
        return player != null;
    }  
}
