 

import greenfoot.*; // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

// import java.awt.Toolkit;  

public class StartMenu extends World {
	private double transparency;
	private GreenfootImage bg = getBackground();
	GreenfootImage levels = new GreenfootImage("Levels.png");
	GreenfootImage endless = new GreenfootImage("Endless.png");
	Image control = new Image("Mouse.gif", new Integer[] { 150, 100 });
	Button level = new Button(120, 50, "", 1, levels);
	Button endles = new Button(120, 50, "", 0, endless);
	// public static GreenfootSound opening = new
	// GreenfootSound("Opening Titles.mp3");
	private static boolean mouseC;
	public static int leve;
	private ComboBox mySelectList;
	private ComboBox myLevelList;

	// private static int width =
	// Toolkit.getDefaultToolkit().getScreenSize().width;
	// private static int height =
	// Toolkit.getDefaultToolkit().getScreenSize().height;

	@SuppressWarnings({ "serial", "rawtypes", "unchecked" })
	public StartMenu() {
		super(1000, 600, 1);
		// super(width, height, 1);

		mouseC = true;
		transparency = System.currentTimeMillis();
		Greenfoot.start();
		bg.setTransparency(0);
		levels.setTransparency(0);
		endless.setTransparency(0);
		addObject(level, getWidth() / 4, getHeight() - 50);
		addObject(endles, getWidth() / 4 * 3, getHeight() - 50);
		addObject(control, 100, 220);
		mySelectList = new ComboBox(new ArrayList<String>() {
			{
				add("Mouse");
				add("Keyboard");
			}
		}, Greenfoot.getRandomNumber(2));
		addObject(mySelectList, 100, 150);
		setControl();
		// if(UserInfo.isStorageAvailable())
		// {
		// if(UserInfo.getMyInfo() != null)
		// {
		// UserInfo playerData = UserInfo.getMyInfo();
		// getBackground().drawImage(playerData.getUserImage(), 15, 25);
		// getBackground().setColor(Color.RED);
		// leve = playerData.getInt(0);
		// if(leve == 0) leve=1;
		// ArrayList levelList = new ArrayList<String>(){{}};
		// for(int i = leve; i > 0; i--)
		// {
		// levelList.add(i + "");
		// }
		// myLevelList = new ComboBox(levelList, 0);
		// addObject(myLevelList, getWidth()/4, getHeight() - 120);
		// setLevel();
		// getBackground().drawString("Level: ", getWidth()/4 - 40, getHeight()
		// - 115);
		// getBackground().drawString("Score: " + playerData.getScore(),
		// getWidth()/4*3, getHeight() - 120);
		// } else
		// {
		// leve = 1;
		// ArrayList levelList = new ArrayList<String>(){{}};
		// for(int i = leve; i > 0; i--)
		// {
		// levelList.add(i + "");
		// }
		// myLevelList = new ComboBox(levelList, 0);
		// addObject(myLevelList, getWidth()/4, getHeight() - 120);
		// setLevel();
		// }
		// } else
		// {
		leve = 1;
		ArrayList levelList = new ArrayList<String>() {
			{
			}
		};
		for (int i = leve; i > 0; i--) {
			levelList.add(i + "");
		}
		myLevelList = new ComboBox(levelList, 0);
		addObject(myLevelList, getWidth() / 4, getHeight() - 120);
		setLevel();
		// }
	}

	public static boolean getC() {
		return mouseC;
	}

	public static int getLevel() {
		return leve;
	}

	public void act() {
		if (bg.getTransparency() < 255) {
			if (System.currentTimeMillis() > transparency + 10) {
				if (endless.getTransparency() < 254
						&& levels.getTransparency() < 254) {
					endless.setTransparency((endless.getTransparency() + 2));
					levels.setTransparency((endless.getTransparency() + 2));
				}
				bg.setTransparency((bg.getTransparency() + 1));
				transparency = System.currentTimeMillis();
			}
		}
		if (mySelectList.hasChanged()) {
			setControl();
		}
		if (myLevelList.hasChanged()) {
			setLevel();
		}
	}

	private void setControl() {
		switch (mySelectList.getIndex()) {
		case 0:
			mouseC = true;
			control.setImages(new GreenfootImage("Mouse.gif"));
			break;
		case 1:
			mouseC = false;
			control.setImages(new GreenfootImage("Keyboard.gif"));
			break;
		}
	}

	private void setLevel() {
		leve = Integer.parseInt(myLevelList.getSelected());
	}
}