package greenfoot;

class KeyInfo
{
    boolean up;
	boolean down;
	boolean left;
	boolean right;
	boolean space;
	String lastKey;
	
	KeyInfo(){
		KeyInfo xk = Greenfoot.touchManager.currentKeyInfo;
		if(xk != null)
			lastKey = xk.lastKey;
		else
		    lastKey = null;
			
		up = false;
		down = false;
		left = false;
		right = false;
		space = false;
	}
	
	boolean isKeyDown(String keyName){
		if(keyName.equals("up"))
			return up;
		else if(keyName.equals("down"))
			return down;
		else if(keyName.equals("left"))
			return left;
		else if(keyName.equals("right"))
			return right;
		else if(keyName.equals("space"))
			return space;
		else
		return false;
	}
}
