package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Enemy Body class
 */
public class Enemies extends EnemiesStuff
{
    /**
     * Checking if something is on the same position
     */
    @SuppressWarnings("rawtypes")
	public boolean touches(Class clss)
    {
        Actor enemy = getOneIntersectingObject(clss);
        return enemy != null;
    }

    /**
     * Checking if a light class enemy is on the same position
     * if there is one, removing so there is nothing overlapping
     */
    public void overlapping3()
    {
        if(touches(Death_Glider.class))
        {
            remove(Death_Glider.class);
        }
    }    

    /** 
     * Checking if a light or middle class enemy is on the same position
     * if there is one, removing so there is nothing overlapping
     */
    public void overlapping2()
    {
        if(touches(Wraith_Dart.class))
        {
            remove(Wraith_Dart.class);
        }
        overlapping3();
    }

    /** 
     * Checking if an enemy is on the same position
     * if there is one, removing so there is nothing overlapping
     */
    public void overlapping1()
    {
        if(touches(Alkesh.class))
        {
            remove(Alkesh.class);
        }
        overlapping2();
    }

    /**
     * removes something on the same position
     */
    @SuppressWarnings("rawtypes")
	public void remove(Class clss)
    {
        Actor drone = getOneIntersectingObject(clss);
        if(drone != null) {
            getWorld().removeObject(drone); 
        }
    }
}