package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class F302_bullet extends F302_attack
{
    private static final int speed = 40;
    public static int damage = 100;

    /**
     * moving right
     */
    public void moveRight()
    {
        setLocation (getX() + speed, getY());
    }

    /**
     * removing objects on the position
     */
    @SuppressWarnings("rawtypes")
	public void remove(Class clss)
    {
        Actor drone = getOneIntersectingObject(clss);
        if(drone != null) {
            getWorld().removeObject(drone); 
        }
    }

    /**
     * playing Sound, setting damage variable
     */
    public F302_bullet()
    {
        //Greenfoot.playSound("bullet.wav");
        damage = 10;
    }

    public void act() 
    {
        if(getX() < 995)
        {
                moveRight();
        } else
        {
            getWorld().removeObject(this);
        }
    }
}