package stargate;

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class JumperShield here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class JumperShield extends JumperStuff
{
    @SuppressWarnings("unused")
	private boolean removed;
    private double en;
    private double radius;

    /**
     * setting image, variables
     */
    public JumperShield()
    {
        removed = false;
        GreenfootImage bg = getImage();
        bg.setTransparency(160);
        setImage(bg);
        en = System.currentTimeMillis();
    }

    /**
     * provides damage to the shield
     */
    public void damageToShield(int damage)
    {
        Bar shbar;
        try   
        {
            Endless endless = (Endless) getWorld();
            shbar = endless.shbar;
        }  catch(ClassCastException ex)
        {
            Level level = (Level) getWorld();
            shbar = level.shbar;
        }
        shbar.subtract(damage);
    }

    @SuppressWarnings("unused") // of course it is used
	public void act() 
    {
        if(System.currentTimeMillis() > en + 1000)
        {
            energyNeeded(2);
        }
        boolean died = true;
        try   
        {
            Endless endless = (Endless) getWorld();
            died = endless.died;
        }  catch(ClassCastException ex)
        {
            Level level = (Level) getWorld();
            died = level.died;
        }
        if(!died)
        {
            if(System.currentTimeMillis() > en + 100)    
            {
                if(radius > 359)
                {
                    setRotation(0);
                }
                setRotation(getRotation() + 10);
                en = System.currentTimeMillis();
            }
            boolean shbarEmpty = false;
            try   
            {
                Endless endless = (Endless) getWorld();
                if(endless.shbar.getValue() != 0) shbarEmpty = true;
            }  catch(ClassCastException ex)
            {
                Level level = (Level) getWorld();
                if(level.shbar.getValue() != 0) shbarEmpty = true;
            }

            if(shbarEmpty)
            {
                MouseInfo mouse = Greenfoot.getMouseInfo();  
                Jumper jumper;
                try   
                {
                    Endless endless = (Endless) getWorld();
                    jumper = endless.jumper;
                }  catch(ClassCastException ex)
                {
                    Level level = (Level) getWorld();
                    jumper = level.jumper;
                }
                setLocation(jumper.getX(), jumper.getY());
            } else
            {
                try   
                {
                    Endless endless = (Endless) getWorld();
                    endless.shield = true;
                }  catch(ClassCastException ex)
                {
                    Level level = (Level) getWorld();
                    level.shield = true;
                }
                getWorld().removeObject(this);                
            }    
        } else
        {
            getWorld().removeObject(this);
            System.out.println("shut up");
        }
    }

    /**
     * subtracts damage of the shield energy
     */
    public void energyNeeded(int damage)
    {
        Bar shbar;
        try   
        {
            Endless endless = (Endless) getWorld();
            shbar = endless.shbar;
        }  catch(ClassCastException ex)
        {
            Level level = (Level) getWorld();
            shbar = level.shbar;
        }
        if(shbar.getValue() == 0)
        {
            try   
            {
                Endless endless = (Endless) getWorld();
                endless.shield = true;
            }  catch(ClassCastException ex)
            {
                Level level = (Level) getWorld();
                level.shield = true;
            }
            getWorld().removeObject(this);
        } else
        {
            damageToShield(damage);
        }
    }
}