 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class F302 extends Support
{
    private int speed = 10;
    private int hp = 100;
    private boolean shootDown;

    /**
     * moving right
     */
    public void moveRight()
    {
        setLocation (getX() + speed, getY() );
    }
    
    /**
     * remove objects on position
     */
    @SuppressWarnings("rawtypes")
	public void remove(Class clss)
    {
        Actor drone = getOneIntersectingObject(clss);
        if(drone != null) {
            getWorld().removeObject(drone); 
        }
    }

    /**
     * setting variable
     */
    public F302()
    {
        shootDown = true;
    }

    public void act() 
    {
        if(touches(Naquadah_Explosion.class))
        {
            die();
        }else 
        {
            if(touches(Death_Glider_staff.class))
            {
                remove(Death_Glider_staff.class);
                hp = hp - Death_Glider_staff.damage;
            } else if(touches(Wraith_Dart_energy.class))
            {
                remove(Wraith_Dart_energy.class);
                hp = hp - Wraith_Dart_energy.damage;
            } else if(touches(Alkesh_fire.class))
            {
                remove(Alkesh_fire.class);
                hp = hp - Alkesh_fire.damage;
            }
            if(hp < 10)
            {
                getWorld().addObject(new Explosion(100), getX(), getY());
                die();
            } else
            {
                if(getX() < getWorld().getWidth() - 5)
                {
                    moveRight();
                    if(shootDown)
                    {
                        getWorld().addObject(new F302_bullet(), getX(), getY() + 20);
                        shootDown = false;
                    } else
                    {
                        getWorld().addObject(new F302_bullet(), getX(), getY() - 20);   
                        shootDown = true;
                    }
                } else
                {
                    getWorld().removeObject(this);
                }
            }
        }
    }

    /**
     * completes death
     */
    private void die()
    {
        getWorld().removeObject(this);
    }
}
