 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * F302 Support
 */
public class F302Incoming extends Powerup
{
    private GreenfootImage images;
    private int speed = 1;

    /**
     * setting image
     */
    public F302Incoming()
    {
        images = new GreenfootImage("frame 1 -- f302 powerup.png");
        setImage(images);
    }

    public void act() 
    {
        if(touches(Jumper.class))
        {
            try
            {
                Endless endless = (Endless) getWorld();
                endless.jumperSupport();
            } catch(ClassCastException ex)
            {
                Level level = (Level) getWorld();
                level.jumperSupport();
            }
            getWorld().removeObject(this);
        } else if(!touches(Jumper.class))
        {
            if(getX() > 0)
            {
                moveLeft(speed);
            } else
            {
                getWorld().removeObject(this);
            }
        }
    }
}
