 

import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
/**
 * gives Heavy Weapons
 */
public class HeavyAmmo extends Powerup
{
    private GreenfootImage images;
    private int speed = 2;

    /**
     * setting image
     */
    public HeavyAmmo()
    {
        images = new GreenfootImage("frame 1 -- weapon powerup.png");
        setImage(images);
    }

    public void act() 
    {
        if(touches(Jumper.class))
        {
            try
            {
                Endless endless = (Endless) getWorld();
                endless.addHW(1);
            } catch(ClassCastException ex)
            {
                Level level = (Level) getWorld();
                level.addHW(1);
            }
            getWorld().removeObject(this);
        } else if(!touches(Jumper.class))
        {
            if(getX() > 0)
            {
                moveLeft(speed);
            } else
            {
                getWorld().removeObject(this);
            }
        }
    }
}