 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * The Jumper
 */
public class Jumper extends JumperStuff
{
    public boolean attackRight = true;
    public int mouseY;
    public int mouseX;

    /**
     * returns if a key is pressed
     */
    public boolean key(String key)
    {
        if(Greenfoot.isKeyDown(key))
        {
            return true;
        } else
        {
            return false;
        }
    }

    /**
     * firing Drones
     */
    public void drones()
    {
        if(attackRight)
        {
            getWorld().addObject(new Drone(), getX(), getY() - 30);
            attackRight = false;
        } else
        {
            getWorld().addObject(new Drone(), getX(), getY() + 30);
            attackRight = true;                
        }
    }

    /**
     * firing naquadah_bomb
     */
    public void n_bomb()
    {
        if(attackRight)
        {
            getWorld().addObject(new N_bomb(), getX() - 30, getY());
            attackRight = false;
        } else
        {
            getWorld().addObject(new N_bomb(), getX(), getY());
            attackRight = true;                
        }
    }

    boolean mouseC = false;

    @SuppressWarnings("unused") // eclipse must be kidding
	public Jumper()
    {
        Object[] options = {"Keyboard", "Mouse"};
        mouseC = true; //StartMenu.getC();
    }

    public boolean canMove = true;

    public void act() 
    {
        if(canMove)
        {
            if(mouseC)
            {
                MouseInfo mouse = Greenfoot.getMouseInfo();  
                if(mouse!=null)
                {  
                    if (Greenfoot.mouseClicked(null) && mouseLocation("left")) {
                        mouseY = Greenfoot.getMouseInfo().getY();
                        mouseX = Greenfoot.getMouseInfo().getX();
                    } 
                    if(getY() > 109)
                    {
                        if(mouseY < getY())
                        {
                            setLocation(getX(), getY() - 5);
                        }
                    }
                    if(getY() < 554)
                    {
                        if(mouseY > getY())
                        {
                            setLocation(getX(), getY() + 5);
                        }
                    }
                }
            } else
            {
                if(getY() > 109)
                {
                    if(key("up") || key("W"))
                    {
                        setLocation(getX(), getY() - 5);
                    }
                }
                if(getY() < 554)
                {
                    if(key("down") || key("S"))
                    {
                        setLocation(getX(), getY() + 5);
                    }
                }
            }
        }
    }   
    
	public boolean mouseLocation(String loc) {
		MouseInfo mouse = Greenfoot.getMouseInfo();
		int mouseX = mouse.getX();
		int mouseY = mouse.getY();
		if (loc.equals("right") && mouseX > getWorld().getWidth() / 3 * 2)
			return true;
		if (loc.equals("up") && mouseY < getWorld().getHeight() / 3)
			return true;
		if (loc.equals("left") && mouseX < getWorld().getWidth() / 3)
			return true;
		if (loc.equals("down") && mouseY > getWorld().getHeight() / 3 * 2)
			return true;
		return false;
	}
}