 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;  
import java.awt.Color;
/**
 * Write a description of class Level here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level extends World
{
    public GreenfootImage user;
    GreenfootImage userImg;
    private boolean userImage;

    private static final GreenfootImage bgImage = new GreenfootImage("space2.jpg");
    private static final int scrollSpeed = 2;
    private GreenfootImage scrollingImage;
    private int scrollPosition = 0;

    public Jumper jumper;
    public Bar hpbar = new Bar("", "Health Points", 60, 60, Color.RED, Color.GREEN);
    public Bar hwbar = new Bar("", "Heavy Munition", 5, 10, Color.RED, Color.RED);
    public Bar lwbar = new Bar("", "Light Munition", 50, 50, Color.RED, Color.RED);
    public Bar shbar = new Bar("", "Shield Power", 100, 200, Color.YELLOW, Color.YELLOW);

    private int level;

    /**
     * Constructor for objects of class Level.
     * 
     */
    public Level()
    {    
        super(1000, 600, 1); 
        GreenfootImage background = new GreenfootImage(1000, 600);
        scrollingImage = getScrollingImage(1000, 600);
        background.drawImage(scrollingImage, 0, 0);
        setBackground(background); 
        level=StartMenu.leve;
        if(level == 0) level=1;
        setPaintOrder(ScoreBoard.class, JumperShield.class, Jumper.class, Enemies.class, Enemies_attack.class, Bar.class, Explosion.class,Drone.class, N_bomb.class, Powerup.class);
//         addObject(new Counter("Time: "), 200, 50);
        addObject(hpbar, getWidth() / 2, 20);
        addObject(lwbar, getWidth() / 2, 40);
        addObject(hwbar, getWidth() / 2, 60);
        addObject(shbar, getWidth() / 2, 80);
        shoot = true;
        scroll = true;
        jumper = new Jumper();
        nextLevel(false);
    }

    private boolean shoot;
    private boolean scroll;
    public int button;
    public int shootHW = 0;
    public boolean died = false;
    @SuppressWarnings("unused")
	private boolean spawnEnemies = true;
    private boolean reproduce = true;
    public boolean shield = true;

    private double sh = 0;
    private double bombs;
    private double drones;
    private boolean zpm;
    private double zpmt;

    @SuppressWarnings("unused")
	public void act()
    {
        if(shoot)
        {
            if(jumper.mouseC)
            {
                MouseInfo mouse = Greenfoot.getMouseInfo();  
                int button;
                if(Greenfoot.mouseClicked(null))
                {
                    button = mouse.getButton();  
                    if(button == 1) 
                    {
                        if(lwbar.getValue() > 0)
                        {
                            if(System.currentTimeMillis() > drones + 100)
                            {
                                jumper.drones();
                                lwbar.subtract(1); 
                                drones = System.currentTimeMillis();
                            }
                        }
                    } else if(button == 2)
                    {
                        if(shield  && System.currentTimeMillis() > sh + 1000)
                        {
                            addObject(new JumperShield(), jumper.getX(), jumper.getY());
                            shield = false;
                            sh = System.currentTimeMillis();
                        } else if(!shield && System.currentTimeMillis() > sh + 1000)
                        {
                            try
                            {
                                removeObject(((JumperShield)getObjects(JumperShield.class).get(0)));
                                shield = true;   
                            } catch (IndexOutOfBoundsException as)
                            {

                            } 
                            sh = System.currentTimeMillis();
                        }
                    } else if(button == 3) 
                    {
                        if(hwbar.getValue() > 0)
                        {
                            if(System.currentTimeMillis() > bombs + 3000)
                            {
                                jumper.n_bomb();
                                shootHW = 2;
                                hwbar.subtract(1); 
                                bombs = System.currentTimeMillis();
                            }
                        }
                    }
                }
            } else
            {
                if(key("J")) 
                {
                    if(lwbar.getValue() > 0)
                    {
                        if(System.currentTimeMillis() > drones + 400)
                        {
                            jumper.drones();
                            lwbar.subtract(1); 
                            drones = System.currentTimeMillis();
                        }
                    }
                } else if(key("K"))
                {
                    if(shield  && System.currentTimeMillis() > sh + 1000)
                    {
                        addObject(new JumperShield(), jumper.getX(), jumper.getY());
                        shield = false;
                        sh = System.currentTimeMillis();
                    } else if(!shield && System.currentTimeMillis() > sh + 1000)
                    {
                        try
                        {
                            removeObject(((JumperShield)getObjects(JumperShield.class).get(0)));
                            shield = true;   
                        } catch (IndexOutOfBoundsException as)
                        {

                        } 
                        sh = System.currentTimeMillis();
                    }
                } else if(key("L")) 
                {
                    if(hwbar.getValue() > 0)
                    {
                        if(System.currentTimeMillis() > bombs + 3000)
                        {
                            jumper.n_bomb();
                            shootHW = 2;
                            hwbar.subtract(1); 
                            bombs = System.currentTimeMillis();
                        }
                    }
                }
            }
        }
        if(Greenfoot.isKeyDown("m"))
        {
            //StartMenu.opening.stop();
        }
        if(scroll)
        {
            if(scrollSpeed > 0 && scrollPosition <= 0) {
                scrollPosition = getWidth();
            }
            if(scrollSpeed < 0 && scrollPosition >= getWidth()) {
                scrollPosition = 0;
            }
            scrollPosition -= scrollSpeed;
            paint(scrollPosition);
        }
        if(hpbar.getValue() < 1)
        {
            if(!died)
            {
                addObject(new Explosion(200), jumper.getX(), jumper.getY());
                removeObject(jumper);
                shoot = false;
                scroll = false;
                spawnEnemies = false;
                died = true;
                reproduce = false;
                shield = false;
            }
            if(numberOfObjects() == 5)
            {
                dye();
            }
        } 
        if(reproduce)
        {
            reproducing();   
        }
        if(zpm)
        {
            if(zpmt == 0) {zpmt = System.currentTimeMillis();  jumper.setImage("jumper_zpm.png");}
            if(System.currentTimeMillis() < zpmt + (60 * 1000))
            {
                shbar.setValue(200);
                lwbar.setValue(50);
                jumper.setImage("jumper_zpm.png");
            } else
            {
                setZPM(false);
                zpmt = 0;
                jumper.setImage("jumper.png");
            }
        }
        actL();
    }

    private double startTime;
    private Actor boss;
    private int time;
    private boolean won;

    private void actL()
    {
        time = (int) ((System.currentTimeMillis() - startTime) / 1000);
        if(level == 1)
        {  
            if(!won)
            {
                if(time < 10)
                {
                    if(getObjects(Death_Glider.class).size() < time / 4 && getObjects(Death_Glider.class).size() < 1) 
                        if(Greenfoot.getRandomNumber(time * 2) >= 15)
                            spawn("Death_Glider", Greenfoot.getRandomNumber(10));
                }else if(time > 12 && time < 120)
                {
                    if(getObjects(Death_Glider.class).size() < 1) 
                        if(Greenfoot.getRandomNumber(time * 3) >= 60) 
                            spawn("Death_Glider", Greenfoot.getRandomNumber(5));
                    //                 if(getObjects(Wraith_Dart.class).size() < (time) / 2 && getObjects(Wraith_Dart.class).size() < 1) 
                    //                     if(Greenfoot.getRandomNumber(time * 2) >= 150) 
                    //                         spawn("Wraith_Dart", Greenfoot.getRandomNumber(4));
                } else if(time >= 130 && boss == null)
                {
                    boss = new Death_Glider();
                    addObject(boss, getWidth() + 100, getHeight() / 2);
                } else if(time > 132 && boss != null && boss.getWorld() != null)
                {
                    if(boss.getX() < getWidth() - 200)
                        boss.setLocation(getWidth() - 200, boss.getY());
                    switch(Greenfoot.getRandomNumber(4))
                    {
                        case 0: boss.setLocation(boss.getX(), boss.getY() + 5); break;
                        case 1: boss.setLocation(boss.getX(), boss.getY() - 5); break;
                        case 2: boss.setLocation(boss.getX(), boss.getY() + 10); break;
                        case 3: boss.setLocation(boss.getX(), boss.getY() - 10); break;
                    }
                } else if(boss != null && boss.getWorld() == null && time > 140)
                {
                    startTime = System.currentTimeMillis();
                    won = true;
                    scroll = false;
                }
            } else
            {
                if(jumper.getX() <= 995)
                {
                    if(System.currentTimeMillis() > startTime + 5)
                    {
                        startTime = System.currentTimeMillis();
                        jumper.setLocation(jumper.getX() + 5, jumper.getY());
                    }
                } else
                {
                    removeObject(jumper);
                    nextLevel(true);
                }
            }
        } else if(level == 2)
        {  
            if(!won)
            {
                if(time < 50)
                {
                    if(getObjects(Death_Glider.class).size() < 1) 
                        if(Greenfoot.getRandomNumber(time * 2 + 1) >= 15)
                            spawn("Death_Glider", Greenfoot.getRandomNumber(10));
                }else if(time > 50 && time < 200)
                {
                    if(getObjects(Death_Glider.class).size() < 2) 
                        if(Greenfoot.getRandomNumber(time * 3) >= 60) 
                            spawn("Death_Glider", Greenfoot.getRandomNumber(5));
                } 
                if(time >= 150 && boss == null)
                {
                    boss = new Death_Glider();
                    addObject(boss, getWidth() + 100, getHeight() / 2);
                } else if(time > 151 && boss != null && boss.getWorld() != null)
                {
                    if(boss.getX() < getWidth() - 200)
                        boss.setLocation(getWidth() - 200, boss.getY());
                    switch(Greenfoot.getRandomNumber(4))
                    {
                        case 0: boss.setLocation(boss.getX(), boss.getY() + 7); break;
                        case 1: boss.setLocation(boss.getX(), boss.getY() - 7); break;
                        case 2: boss.setLocation(boss.getX(), boss.getY() + 13); break;
                        case 3: boss.setLocation(boss.getX(), boss.getY() - 13); break;
                    }
                } else if(boss != null && boss.getWorld() == null && time > 200)
                {
                    startTime = System.currentTimeMillis();
                    won = true;
                    scroll = false;
                }
            } else
            {
                if(jumper.getX() <= 995)
                {
                    if(System.currentTimeMillis() > startTime + 5)
                    {
                        startTime = System.currentTimeMillis();
                        jumper.setLocation(jumper.getX() + 5, jumper.getY());
                    }
                } else
                {
                    removeObject(jumper);
                    nextLevel(true);
                }
            }
        } else if(level == 3)
        {  
            if(!won)
            {
                if(time < 50)
                {
                    if(getObjects(Death_Glider.class).size() < 2) 
                        if(Greenfoot.getRandomNumber(time * 2 + 1) >= 15)
                            spawn("Death_Glider", Greenfoot.getRandomNumber(10));
                }else if(time > 50 && time < 120)
                {
                    if(getObjects(Death_Glider.class).size() < 4) 
                        if(Greenfoot.getRandomNumber(time * 3) >= 60) 
                            spawn("Death_Glider", Greenfoot.getRandomNumber(5));
                } 
                if(time >= 100 && boss == null)
                {
                    boss = new Wraith_Dart();
                    addObject(boss, getWidth() + 100, getHeight() / 2);
                } else if(time > 151 && boss != null && boss.getWorld() != null)
                {
                    if(boss.getX() < getWidth() - 200)
                        boss.setLocation(getWidth() - 200, boss.getY());
                    switch(Greenfoot.getRandomNumber(4))
                    {
                        case 0: boss.setLocation(boss.getX(), boss.getY() + 7); break;
                        case 1: boss.setLocation(boss.getX(), boss.getY() - 7); break;
                        case 2: boss.setLocation(boss.getX(), boss.getY() + 13); break;
                        case 3: boss.setLocation(boss.getX(), boss.getY() - 13); break;
                    }
                } else if(boss != null && boss.getWorld() == null && time > 200)
                {
                    startTime = System.currentTimeMillis();
                    won = true;
                    scroll = false;
                }
            } else
            {
                if(jumper.getX() <= 995)
                {
                    if(System.currentTimeMillis() > startTime + 5)
                    {
                        startTime = System.currentTimeMillis();
                        jumper.setLocation(jumper.getX() + 5, jumper.getY());
                    }
                } else
                {
                    removeObject(jumper);
                    //                     nextLevel(true);
                    getBackground().setColor(Color.GREEN);
                    getBackground().drawString("Congratulations. You finished all levels available.", getWidth()/2, getHeight()/1);
                }
            }
        }
    }

    @SuppressWarnings("rawtypes")
	public void nextLevel(boolean next)
    {
        if(next)  
            level++;
        storeData(level, 0);
        List removable = getObjects(null);
        Iterator i = removable.iterator();
        while(i.hasNext()) {
            Actor a = (Actor) i.next();
            if( ! (a instanceof Interface)) 
                if(!(a instanceof Explosion))
                    removeObject(a);
        }
        jumper = new Jumper();
        addObject(jumper, 43, 314);
        boss = null;
        hpbar.setValue(60);
        lwbar.setValue(50);
        shbar.setValue(200);
        won = false;
        scroll = true;
        startTime = System.currentTimeMillis();
    }

    public int getLevel()
    {
        return level;
    }

    public int getTime()
    {
        return time;
    }

    public void spawnS(String type)      
    {      
        addObject(createActor(type), 1, 120);      
        addObject(createActor(type), 1, 200);      
        addObject(createActor(type), 1, 300);      
        addObject(createActor(type), 1, 400);      
        addObject(createActor(type), 1, 500);      
    }  

    private double lwreproduce = System.currentTimeMillis();
    private double shreproduce = System.currentTimeMillis();

    private void reproducing()
    {
        if(System.currentTimeMillis() > lwreproduce + 800)
        {
            lwreproduce = System.currentTimeMillis();
            lwbar.add(1);
        }
        if(System.currentTimeMillis() > shreproduce + 1300)
        {
            shreproduce = System.currentTimeMillis();
            shbar.add(1);
        }
    }

    /**
     * returns if a key is pressed
     */
    public boolean key(String key)
    {
        if(Greenfoot.isKeyDown(key))
        {
            return true;
        } else
        {
            return false;
        }
    }

    private Actor createActor(String type)  
    {  
        if (type.equals("F302")) return new F302(); 
        if (type.equals("Alkesh")) return new Alkesh(); 
        if (type.equals("Wraith_Dart")) return new Wraith_Dart();
        if (type.equals("Death_Glider")) return new Death_Glider();  
        if (type.equals("Jumper_shield")) return new JumperShield(); 
        return new F302_bullet();  
    }  

    public void addHW(int HW)
    {
        hwbar.add(HW);
    }

    public void setZPM(boolean setting)
    {
        zpm = setting; 
    }

    public void jumperSupport()
    {
        spawnS("F302");
    }

    public void dye()/**adds the scoreboard telling you what level you were on*/
    {

    }

    public void spawn(String type, int position)
    {
        switch(position)
        {
            case 0: addObject(createActor(type), getWidth(), 120); break;
            case 1: addObject(createActor(type), getWidth(), 200); break;
            case 2: addObject(createActor(type), getWidth(), 300); break;
            case 3: addObject(createActor(type), getWidth(), 400); break;
            case 4: addObject(createActor(type), getWidth(), 500); break;
            case 5: addObject(createActor(type), getWidth(), 160); break;
            case 6: addObject(createActor(type), getWidth(), 250); break;
            case 7: addObject(createActor(type), getWidth(), 350); break;
            case 8: addObject(createActor(type), getWidth(), 450); break;
            case 9: addObject(createActor(type), getWidth(), 560); break;
        }
    }

    /**
     * Paint scrolling image at given position and make sure the rest of
     * the background is also painted with the same image.
     */
    private void paint(int position)
    {
        GreenfootImage bg = getBackground();
        bg.drawImage(scrollingImage, position, 0);
        bg.drawImage(scrollingImage, position - scrollingImage.getWidth(), 0);
        if(userImage)  
        {
            bg.drawImage(userImg, 25, 25);
        }
    }

    /**
     * Returns an image with the given dimensions.
     */
    private GreenfootImage getScrollingImage(int width, int height)
    {
        GreenfootImage image = new GreenfootImage(width, height);
        for(int x = 0; x < width; x += bgImage.getWidth()) 
        {
            for(int y = 0; y < height; y += bgImage.getHeight()) 
            {
                image.drawImage(bgImage, x, y);
			}
		}
        return image;
    }

    private void storeData(int level, int index)
    {
/*        if(UserInfo.isStorageAvailable())  
        {
            UserInfo me = UserInfo.getMyInfo();
            if (me != null)
            {
                if (level > me.getInt(index))
                {
                    me.setInt(index, level);
                    me.store();
                }
            }
        }*/
    }
}