 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Wraith_Dart here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Wraith_Dart extends Enemies
{
    private int speed = 4;
    private int hp = 200;
    private boolean shootDown;
    private boolean initiated;

    /**
     * moving left
     */
    public void moveLeft()
    {
        setLocation(getX() - speed, getY() );
    }

    /**
     * setting variables
     */

    public Wraith_Dart()
    {
        initiated = false;
        shootDown = true;
    }

    public void act() 
    {
        if(!initiated)
        {
            super.overlapping2();
            initiated = true;
        }
        if(touches(N_bomb.class))
        {
            getWorld().addObject(new Naquadah_Explosion(), getX(), getY());
            remove(N_bomb.class);
            die();
        } else if(touches(Naquadah_Explosion.class))
        {
            die();
        } else if(touches(F302_bullet.class))
        {
            die();
        }else 
        {
            if(touches(Drone.class))
            {
                remove(Drone.class);
                hp = hp - Drone.damage;
            }
            if(hp < 10)
            {
                die();
            } else
            {
                if(getX() > 1)
                {
                    moveLeft();
                    int shoot = Greenfoot.getRandomNumber(50);
                    if(shoot == 2)
                    {
                        if(shootDown)
                        {
                            getWorld().addObject(new Wraith_Dart_energy(), getX(), getY() + 20);
                            shootDown = false;
                        } else
                        {
                            getWorld().addObject(new Wraith_Dart_energy(), getX(), getY() - 20);   
                            shootDown = true;
                        }
                    }
                } else
                {
                    getWorld().removeObject(this);
                }
            }
        }
    }

    /**
     * completes death with chance to produce a powerup
     */
    private void die()
    {
        int heavyAmmo = Greenfoot.getRandomNumber(10) + 1;
        switch(heavyAmmo)
        {
            case 7: getWorld().addObject(new HeavyAmmo(), getX(), getY());
        }
        getWorld().addObject(new Explosion(200), getX(), getY());
        try
        {
            Endless endless = (Endless) getWorld(); 
            endless.addScore(20);
        } catch(ClassCastException es) {}
        getWorld().removeObject(this);
    }
}
